Hex Artifact Content

Artifact dd4b10f4578b21343100fd198995d3f073c3ed10:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 23 20 43 6c 65 61 6e 20 76 61  bash..# Clean va
0020: 72 69 61 62 6c 65 73 20 77 68 69 63 68 20 77 69  riables which wi
0030: 6c 6c 20 69 6e 74 65 72 66 65 72 65 20 77 69 74  ll interfere wit
0040: 68 20 74 68 65 20 62 75 69 6c 64 0a 75 6e 73 65  h the build.unse
0050: 74 20 4d 41 4b 45 46 4c 41 47 53 20 44 45 53 54  t MAKEFLAGS DEST
0060: 44 49 52 0a 0a 23 20 44 65 74 65 72 6d 69 6e 65  DIR..# Determine
0070: 20 61 70 70 72 6f 70 72 69 61 74 65 20 6d 6f 64   appropriate mod
0080: 65 0a 6d 6f 64 65 3d 22 62 75 69 6c 64 22 0a 63  e.mode="build".c
0090: 61 73 65 20 22 24 31 22 20 69 6e 0a 09 63 6c 65  ase "$1" in..cle
00a0: 61 6e 7c 64 69 73 74 63 6c 65 61 6e 7c 62 75 69  an|distclean|bui
00b0: 6c 64 7c 72 65 74 72 79 29 0a 09 09 6d 6f 64 65  ld|retry)...mode
00c0: 3d 22 24 31 22 0a 09 09 73 68 69 66 74 0a 09 09  ="$1"...shift...
00d0: 3b 3b 0a 65 73 61 63 0a 0a 23 20 44 65 74 65 72  ;;.esac..# Deter
00e0: 6d 69 6e 65 20 77 68 69 63 68 20 54 63 6c 20 76  mine which Tcl v
00f0: 65 72 73 69 6f 6e 20 74 6f 20 62 75 69 6c 64 0a  ersion to build.
0100: 54 43 4c 56 45 52 53 3d 22 38 2e 36 2e 38 22 0a  TCLVERS="8.6.8".
0110: 69 66 20 65 63 68 6f 20 22 24 31 22 20 7c 20 67  if echo "$1" | g
0120: 72 65 70 20 27 5e 5b 30 2d 39 5d 5b 30 2d 39 5d  rep '^[0-9][0-9]
0130: 2a 5c 2e 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20  *\.' >/dev/null 
0140: 7c 7c 20 65 63 68 6f 20 22 24 31 22 20 7c 20 65  || echo "$1" | e
0150: 67 72 65 70 20 27 5e 28 63 76 73 7c 66 6f 73 73  grep '^(cvs|foss
0160: 69 6c 29 5f 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c  il)_' >/dev/null
0170: 3b 20 74 68 65 6e 0a 09 54 43 4c 56 45 52 53 3d  ; then..TCLVERS=
0180: 22 24 31 22 0a 0a 09 73 68 69 66 74 0a 66 69 0a  "$1"...shift.fi.
0190: 65 78 70 6f 72 74 20 54 43 4c 56 45 52 53 0a 0a  export TCLVERS..
01a0: 23 20 41 64 64 20 74 68 65 20 68 65 6c 70 65 72  # Add the helper
01b0: 73 20 64 69 72 65 63 74 6f 72 79 20 74 6f 20 74  s directory to t
01c0: 68 65 20 70 61 74 68 0a 50 41 54 48 3d 22 24 28  he path.PATH="$(
01d0: 63 64 20 22 24 28 64 69 72 6e 61 6d 65 20 22 24  cd "$(dirname "$
01e0: 28 77 68 69 63 68 20 22 24 30 22 29 22 29 22 20  (which "$0")")" 
01f0: 26 26 20 70 77 64 29 22 2f 63 6f 6d 6d 6f 6e 2f  && pwd)"/common/
0200: 68 65 6c 70 65 72 73 3a 22 24 7b 50 41 54 48 7d  helpers:"${PATH}
0210: 22 0a 65 78 70 6f 72 74 20 50 41 54 48 0a 0a 23  ".export PATH..#
0220: 20 56 65 72 69 66 79 20 74 68 61 74 20 22 70 72   Verify that "pr
0230: 65 2e 73 68 22 20 68 61 73 20 62 65 65 6e 20 72  e.sh" has been r
0240: 75 6e 20 69 66 20 74 68 69 73 20 69 73 20 61 20  un if this is a 
0250: 64 65 76 65 6c 6f 70 6d 65 6e 74 20 73 6e 61 70  development snap
0260: 73 68 6f 74 20 6f 66 0a 23 20 4b 69 74 43 72 65  shot of.# KitCre
0270: 61 74 6f 72 0a 69 66 20 5b 20 2d 66 20 27 62 75  ator.if [ -f 'bu
0280: 69 6c 64 2f 70 72 65 2e 73 68 27 20 5d 3b 20 74  ild/pre.sh' ]; t
0290: 68 65 6e 0a 09 69 66 20 21 20 66 69 6e 64 20 27  hen..if ! find '
02a0: 6b 69 74 73 68 2f 62 75 69 6c 64 73 72 63 2f 27  kitsh/buildsrc/'
02b0: 20 2d 6e 61 6d 65 20 63 6f 6e 66 69 67 75 72 65   -name configure
02c0: 20 2d 74 79 70 65 20 66 20 32 3e 2f 64 65 76 2f   -type f 2>/dev/
02d0: 6e 75 6c 6c 20 7c 20 67 72 65 70 20 63 6f 6e 66  null | grep conf
02e0: 69 67 75 72 65 20 3e 2f 64 65 76 2f 6e 75 6c 6c  igure >/dev/null
02f0: 3b 20 74 68 65 6e 0a 09 09 65 63 68 6f 20 22 50  ; then...echo "P
0300: 6c 65 61 73 65 20 72 65 6d 65 6d 62 65 72 20 74  lease remember t
0310: 6f 20 72 75 6e 20 27 62 75 69 6c 64 2f 70 72 65  o run 'build/pre
0320: 2e 73 68 27 20 69 66 20 79 6f 75 20 65 78 70 65  .sh' if you expe
0330: 63 74 20 74 68 69 73 20 62 75 69 6c 64 20 74 6f  ct this build to
0340: 20 77 6f 72 6b 2e 22 20 3e 26 32 0a 09 66 69 0a   work." >&2..fi.
0350: 66 69 0a 0a 23 20 44 65 66 69 6e 65 20 74 68 65  fi..# Define the
0360: 20 6c 69 73 74 20 6f 66 20 61 6c 6c 20 70 61 63   list of all pac
0370: 6b 61 67 65 73 2c 20 66 6f 72 20 63 6c 65 61 6e  kages, for clean
0380: 69 6e 67 20 70 75 72 70 6f 73 65 73 0a 4b 49 54  ing purposes.KIT
0390: 43 52 45 41 54 4f 52 5f 41 4c 4c 50 4b 47 53 3d  CREATOR_ALLPKGS=
03a0: 22 6b 69 74 73 68 20 74 63 6c 20 74 63 6c 76 66  "kitsh tcl tclvf
03b0: 73 20 7a 6c 69 62 20 74 6b 20 69 74 63 6c 20 6d  s zlib tk itcl m
03c0: 6b 34 74 63 6c 20 74 68 72 65 61 64 20 64 62 75  k4tcl thread dbu
03d0: 73 20 74 6c 73 20 74 63 6c 78 20 74 63 63 34 74  s tls tclx tcc4t
03e0: 63 6c 20 74 63 6c 6c 69 62 20 75 64 70 20 79 61  cl tcllib udp ya
03f0: 6a 6c 74 63 6c 20 74 64 6f 6d 20 74 75 61 70 69  jltcl tdom tuapi
0400: 20 74 63 6c 63 75 72 6c 20 6c 6d 64 62 20 6e 61   tclcurl lmdb na
0410: 6e 6f 22 0a 0a 23 20 41 6c 77 61 79 73 20 72 65  no"..# Always re
0420: 62 75 69 6c 64 20 6b 69 74 73 68 0a 72 6d 20 2d  build kitsh.rm -
0430: 66 20 22 6b 69 74 73 68 2f 2e 73 75 63 63 65 73  f "kitsh/.succes
0440: 73 22 0a 66 6f 72 20 70 6b 67 20 69 6e 20 24 7b  s".for pkg in ${
0450: 4b 49 54 43 52 45 41 54 4f 52 5f 41 4c 4c 50 4b  KITCREATOR_ALLPK
0460: 47 53 7d 20 24 7b 4b 49 54 43 52 45 41 54 4f 52  GS} ${KITCREATOR
0470: 5f 50 4b 47 53 7d 3b 20 64 6f 0a 09 69 66 20 5b  _PKGS}; do..if [
0480: 20 22 24 7b 6d 6f 64 65 7d 22 20 21 3d 20 22 72   "${mode}" != "r
0490: 65 74 72 79 22 20 2d 6f 20 21 20 2d 66 20 22 24  etry" -o ! -f "$
04a0: 7b 70 6b 67 7d 2f 2e 73 75 63 63 65 73 73 22 20  {pkg}/.success" 
04b0: 5d 3b 20 74 68 65 6e 0a 09 09 72 6d 20 2d 66 20  ]; then...rm -f 
04c0: 22 24 7b 70 6b 67 7d 2f 62 75 69 6c 64 2e 6c 6f  "${pkg}/build.lo
04d0: 67 22 20 22 24 7b 70 6b 67 7d 2f 2e 73 75 63 63  g" "${pkg}/.succ
04e0: 65 73 73 22 0a 09 09 72 6d 20 2d 72 66 20 22 24  ess"...rm -rf "$
04f0: 7b 70 6b 67 7d 2f 6f 75 74 22 20 22 24 7b 70 6b  {pkg}/out" "${pk
0500: 67 7d 2f 69 6e 73 74 22 20 22 24 7b 70 6b 67 7d  g}/inst" "${pkg}
0510: 2f 62 75 69 6c 64 22 0a 0a 09 09 72 6d 20 2d 72  /build"....rm -r
0520: 66 20 22 24 7b 70 6b 67 7d 2f 73 72 63 22 2f 74  f "${pkg}/src"/t
0530: 6d 70 2d 2a 0a 09 66 69 0a 0a 09 69 66 20 5b 20  mp-*..fi...if [ 
0540: 22 24 7b 6d 6f 64 65 7d 22 20 3d 20 22 64 69 73  "${mode}" = "dis
0550: 74 63 6c 65 61 6e 22 20 5d 3b 20 74 68 65 6e 0a  tclean" ]; then.
0560: 09 09 72 6d 20 2d 72 66 20 22 24 7b 70 6b 67 7d  ..rm -rf "${pkg}
0570: 2f 73 72 63 22 0a 09 66 69 0a 64 6f 6e 65 0a 0a  /src"..fi.done..
0580: 23 20 57 65 27 72 65 20 61 6c 6c 20 64 6f 6e 65  # We're all done
0590: 20 69 66 20 77 65 27 72 65 20 69 6e 20 63 6c 65   if we're in cle
05a0: 61 6e 20 6f 72 20 64 69 73 74 63 6c 65 61 6e 20  an or distclean 
05b0: 6d 6f 64 65 0a 69 66 20 5b 20 22 24 7b 6d 6f 64  mode.if [ "${mod
05c0: 65 7d 22 20 3d 20 22 63 6c 65 61 6e 22 20 2d 6f  e}" = "clean" -o
05d0: 20 22 24 7b 6d 6f 64 65 7d 22 20 3d 20 22 64 69   "${mode}" = "di
05e0: 73 74 63 6c 65 61 6e 22 20 5d 3b 20 74 68 65 6e  stclean" ]; then
05f0: 0a 09 72 6d 20 2d 66 20 74 63 6c 6b 69 74 2d 2a  ..rm -f tclkit-*
0600: 0a 09 72 6d 20 2d 66 20 6c 69 62 74 63 6c 6b 69  ..rm -f libtclki
0610: 74 2a 2e 2a 0a 0a 09 65 78 69 74 20 30 0a 66 69  t*.*...exit 0.fi
0620: 0a 0a 23 20 41 64 64 20 70 61 63 6b 61 67 65 73  ..# Add packages
0630: 20 69 6d 70 6c 69 65 64 20 62 79 20 74 68 65 20   implied by the 
0640: 61 64 64 69 74 69 6f 6e 61 6c 20 61 72 67 75 6d  additional argum
0650: 65 6e 74 73 0a 69 66 20 5b 20 2d 7a 20 22 24 7b  ents.if [ -z "${
0660: 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b 47 53 7d  KITCREATOR_PKGS}
0670: 22 20 5d 3b 20 74 68 65 6e 0a 09 4b 49 54 43 52  " ]; then..KITCR
0680: 45 41 54 4f 52 5f 50 4b 47 53 3d 22 74 6b 20 69  EATOR_PKGS="tk i
0690: 74 63 6c 20 6d 6b 34 74 63 6c 22 0a 66 69 0a 0a  tcl mk4tcl".fi..
06a0: 43 4f 4e 46 49 47 55 52 45 45 58 54 52 41 3d 22  CONFIGUREEXTRA="
06b0: 24 40 22 0a 65 78 70 6f 72 74 20 43 4f 4e 46 49  $@".export CONFI
06c0: 47 55 52 45 45 58 54 52 41 0a 0a 69 66 20 65 63  GUREEXTRA..if ec
06d0: 68 6f 20 22 20 24 7b 43 4f 4e 46 49 47 55 52 45  ho " ${CONFIGURE
06e0: 45 58 54 52 41 7d 20 22 20 7c 20 67 72 65 70 20  EXTRA} " | grep 
06f0: 27 20 2d 2d 65 6e 61 62 6c 65 2d 74 68 72 65 61  ' --enable-threa
0700: 64 73 20 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20  ds ' >/dev/null 
0710: 32 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20 74 68 65  2>/dev/null; the
0720: 6e 0a 09 4b 49 54 43 52 45 41 54 4f 52 5f 41 44  n..KITCREATOR_AD
0730: 44 5f 45 4e 41 42 4c 45 5f 54 48 52 45 41 44 53  D_ENABLE_THREADS
0740: 3d 27 31 27 0a 09 4b 49 54 43 52 45 41 54 4f 52  ='1'..KITCREATOR
0750: 5f 50 4b 47 53 3d 22 24 7b 4b 49 54 43 52 45 41  _PKGS="${KITCREA
0760: 54 4f 52 5f 50 4b 47 53 7d 20 74 68 72 65 61 64  TOR_PKGS} thread
0770: 22 0a 65 6c 69 66 20 65 63 68 6f 20 22 20 24 7b  ".elif echo " ${
0780: 43 4f 4e 46 49 47 55 52 45 45 58 54 52 41 7d 20  CONFIGUREEXTRA} 
0790: 22 20 7c 20 67 72 65 70 20 27 20 2d 2d 64 69 73  " | grep ' --dis
07a0: 61 62 6c 65 2d 74 68 72 65 61 64 73 20 27 20 3e  able-threads ' >
07b0: 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76  /dev/null 2>/dev
07c0: 2f 6e 75 6c 6c 3b 20 74 68 65 6e 0a 09 4b 49 54  /null; then..KIT
07d0: 43 52 45 41 54 4f 52 5f 41 44 44 5f 45 4e 41 42  CREATOR_ADD_ENAB
07e0: 4c 45 5f 54 48 52 45 41 44 53 3d 27 30 27 0a 66  LE_THREADS='0'.f
07f0: 69 0a 0a 23 20 44 65 74 65 72 6d 69 6e 65 20 63  i..# Determine c
0800: 72 6f 73 73 2d 63 6f 6d 70 69 6c 65 20 73 74 61  ross-compile sta
0810: 74 75 73 0a 68 6f 73 74 5f 6f 73 3d 22 24 28 65  tus.host_os="$(e
0820: 63 68 6f 20 22 20 24 7b 43 4f 4e 46 49 47 55 52  cho " ${CONFIGUR
0830: 45 45 58 54 52 41 7d 20 22 20 7c 20 73 65 64 20  EEXTRA} " | sed 
0840: 27 73 40 5e 2e 2a 20 2d 2d 68 6f 73 74 3d 5c 28  's@^.* --host=\(
0850: 5b 5e 20 5d 2a 5c 29 20 2e 2a 24 40 5c 31 40 0a  [^ ]*\) .*$@\1@.
0860: 74 20 78 0a 64 0a 3a 78 27 29 22 0a 62 75 69 6c  t x.d.:x')".buil
0870: 64 5f 6f 73 3d 22 24 28 65 63 68 6f 20 22 20 24  d_os="$(echo " $
0880: 7b 43 4f 4e 46 49 47 55 52 45 45 58 54 52 41 7d  {CONFIGUREEXTRA}
0890: 20 22 20 7c 20 73 65 64 20 27 73 40 5e 2e 2a 20   " | sed 's@^.* 
08a0: 2d 2d 62 75 69 6c 64 3d 5c 28 5b 5e 20 5d 2a 5c  --build=\([^ ]*\
08b0: 29 20 2e 2a 24 40 5c 31 40 0a 74 20 78 0a 64 0a  ) .*$@\1@.t x.d.
08c0: 3a 78 27 29 22 0a 0a 69 66 20 5b 20 22 24 7b 68  :x')"..if [ "${h
08d0: 6f 73 74 5f 6f 73 7d 22 20 21 3d 20 22 24 7b 62  ost_os}" != "${b
08e0: 75 69 6c 64 5f 6f 73 7d 22 20 2d 61 20 2d 6e 20  uild_os}" -a -n 
08f0: 22 24 7b 68 6f 73 74 5f 6f 73 7d 22 20 5d 3b 20  "${host_os}" ]; 
0900: 74 68 65 6e 0a 09 4b 43 5f 43 52 4f 53 53 43 4f  then..KC_CROSSCO
0910: 4d 50 49 4c 45 3d 27 31 27 0a 09 4b 43 5f 43 52  MPILE='1'..KC_CR
0920: 4f 53 53 43 4f 4d 50 49 4c 45 5f 48 4f 53 54 5f  OSSCOMPILE_HOST_
0930: 4f 53 3d 22 24 7b 68 6f 73 74 5f 6f 73 7d 22 0a  OS="${host_os}".
0940: 65 6c 73 65 0a 09 4b 43 5f 43 52 4f 53 53 43 4f  else..KC_CROSSCO
0950: 4d 50 49 4c 45 3d 27 30 27 0a 09 4b 43 5f 43 52  MPILE='0'..KC_CR
0960: 4f 53 53 43 4f 4d 50 49 4c 45 5f 48 4f 53 54 5f  OSSCOMPILE_HOST_
0970: 4f 53 3d 27 27 0a 66 69 0a 65 78 70 6f 72 74 20  OS=''.fi.export 
0980: 4b 43 5f 43 52 4f 53 53 43 4f 4d 50 49 4c 45 20  KC_CROSSCOMPILE 
0990: 4b 43 5f 43 52 4f 53 53 43 4f 4d 50 49 4c 45 5f  KC_CROSSCOMPILE_
09a0: 48 4f 53 54 5f 4f 53 0a 0a 23 20 53 65 74 20 64  HOST_OS..# Set d
09b0: 65 66 61 75 6c 74 20 74 61 72 67 65 74 0a 4b 49  efault target.KI
09c0: 54 54 41 52 47 45 54 3d 22 6b 69 74 73 68 22 0a  TTARGET="kitsh".
09d0: 65 78 70 6f 72 74 20 4b 49 54 54 41 52 47 45 54  export KITTARGET
09e0: 0a 0a 23 20 46 69 78 20 75 70 20 70 61 63 6b 61  ..# Fix up packa
09f0: 67 65 20 6c 69 73 74 0a 23 23 20 49 66 20 62 75  ge list.## If bu
0a00: 69 6c 64 69 6e 67 20 4b 69 74 44 4c 4c 2c 20 64  ilding KitDLL, d
0a10: 65 66 69 6e 65 20 69 74 20 61 73 20 6f 75 72 20  efine it as our 
0a20: 74 61 72 67 65 74 0a 69 66 20 65 63 68 6f 20 22  target.if echo "
0a30: 20 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b   ${KITCREATOR_PK
0a40: 47 53 7d 20 22 20 7c 20 67 72 65 70 20 27 20 6b  GS} " | grep ' k
0a50: 69 74 64 6c 6c 20 27 20 3e 2f 64 65 76 2f 6e 75  itdll ' >/dev/nu
0a60: 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20  ll 2>/dev/null; 
0a70: 74 68 65 6e 0a 09 4b 49 54 43 52 45 41 54 4f 52  then..KITCREATOR
0a80: 5f 50 4b 47 53 3d 22 24 28 65 63 68 6f 20 22 20  _PKGS="$(echo " 
0a90: 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b 47  ${KITCREATOR_PKG
0aa0: 53 7d 20 22 20 7c 20 73 65 64 20 27 73 40 20 6b  S} " | sed 's@ k
0ab0: 69 74 64 6c 6c 20 40 20 40 67 3b 73 40 5e 20 20  itdll @ @g;s@^  
0ac0: 2a 40 40 3b 73 40 20 20 2a 24 40 40 3b 73 40 20  *@@;s@  *$@@;s@ 
0ad0: 20 20 2a 40 20 40 67 27 29 22 0a 09 4b 49 54 54    *@ @g')"..KITT
0ae0: 41 52 47 45 54 3d 22 6b 69 74 64 6c 6c 22 0a 66  ARGET="kitdll".f
0af0: 69 0a 0a 23 20 49 66 20 74 68 65 20 75 73 65 72  i..# If the user
0b00: 20 6d 61 6e 75 61 6c 6c 79 20 72 65 71 75 65 73   manually reques
0b10: 74 65 64 20 22 2d 2d 65 6e 61 62 6c 65 2d 6b 69  ted "--enable-ki
0b20: 74 64 6c 6c 22 2c 20 6d 61 6b 65 20 69 74 20 73  tdll", make it s
0b30: 6f 0a 69 66 20 65 63 68 6f 20 22 78 20 24 40 20  o.if echo "x $@ 
0b40: 22 20 7c 20 67 72 65 70 20 27 20 5b 2d 5d 5b 2d  " | grep ' [-][-
0b50: 5d 65 6e 61 62 6c 65 2d 6b 69 74 64 6c 6c 20 27  ]enable-kitdll '
0b60: 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64   >/dev/null 2>/d
0b70: 65 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e 0a 09 4b  ev/null; then..K
0b80: 49 54 54 41 52 47 45 54 3d 22 6b 69 74 64 6c 6c  ITTARGET="kitdll
0b90: 22 0a 66 69 0a 0a 23 23 20 49 66 20 62 75 69 6c  ".fi..## If buil
0ba0: 64 69 6e 67 20 4b 69 74 44 4c 4c 20 61 6e 64 20  ding KitDLL and 
0bb0: 54 6b 2c 20 6d 75 73 74 20 64 6f 20 54 6b 20 73  Tk, must do Tk s
0bc0: 74 61 74 69 63 61 6c 6c 79 0a 23 23 23 20 28 57  tatically.### (W
0bd0: 65 6c 6c 2c 20 77 65 20 64 6f 6e 27 74 20 48 41  ell, we don't HA
0be0: 56 45 20 74 6f 2c 20 62 75 74 20 69 74 20 77 6f  VE to, but it wo
0bf0: 75 6c 64 20 64 65 66 65 61 74 20 6d 75 63 68 20  uld defeat much 
0c00: 6f 66 20 74 68 65 20 70 75 72 70 6f 73 65 29 0a  of the purpose).
0c10: 69 66 20 5b 20 22 24 7b 4b 49 54 54 41 52 47 45  if [ "${KITTARGE
0c20: 54 7d 22 20 3d 20 22 6b 69 74 64 6c 6c 22 20 5d  T}" = "kitdll" ]
0c30: 3b 20 74 68 65 6e 0a 09 69 66 20 65 63 68 6f 20  ; then..if echo 
0c40: 22 20 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f 50  " ${KITCREATOR_P
0c50: 4b 47 53 7d 20 22 20 7c 20 67 72 65 70 20 27 20  KGS} " | grep ' 
0c60: 74 6b 20 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20  tk ' >/dev/null 
0c70: 32 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20 74 68 65  2>/dev/null; the
0c80: 6e 0a 09 09 69 66 20 5b 20 22 24 7b 53 54 41 54  n...if [ "${STAT
0c90: 49 43 54 4b 7d 22 20 21 3d 20 22 31 22 20 2d 61  ICTK}" != "1" -a
0ca0: 20 22 24 7b 53 54 41 54 49 43 54 4b 7d 22 20 21   "${STATICTK}" !
0cb0: 3d 20 22 2d 31 22 20 5d 3b 20 74 68 65 6e 0a 09  = "-1" ]; then..
0cc0: 09 09 65 63 68 6f 20 27 57 61 72 6e 69 6e 67 3a  ..echo 'Warning:
0cd0: 20 4c 69 6e 6b 69 6e 67 20 54 6b 20 73 74 61 74   Linking Tk stat
0ce0: 69 63 61 6c 6c 79 20 62 65 63 61 75 73 65 20 79  ically because y
0cf0: 6f 75 20 61 72 65 20 62 75 69 6c 64 69 6e 67 20  ou are building 
0d00: 4b 69 74 44 4c 4c 27 20 32 3e 26 31 0a 09 09 09  KitDLL' 2>&1....
0d10: 65 63 68 6f 20 27 20 20 20 20 20 20 20 20 20 53  echo '         S
0d20: 65 74 20 53 54 41 54 49 43 54 4b 20 74 6f 20 2d  et STATICTK to -
0d30: 31 20 69 66 20 79 6f 75 20 72 65 61 6c 6c 79 20  1 if you really 
0d40: 77 61 6e 74 20 74 6f 20 6c 69 6e 6b 20 54 6b 20  want to link Tk 
0d50: 64 79 6e 61 6d 69 63 61 6c 6c 79 2e 27 20 3e 26  dynamically.' >&
0d60: 32 0a 0a 09 09 09 53 54 41 54 49 43 54 4b 3d 22  2.....STATICTK="
0d70: 31 22 0a 09 09 09 65 78 70 6f 72 74 20 53 54 41  1"....export STA
0d80: 54 49 43 54 4b 0a 09 09 66 69 0a 09 66 69 0a 0a  TICTK...fi..fi..
0d90: 09 69 66 20 65 63 68 6f 20 22 20 24 7b 4b 49 54  .if echo " ${KIT
0da0: 43 52 45 41 54 4f 52 5f 50 4b 47 53 7d 20 22 20  CREATOR_PKGS} " 
0db0: 7c 20 67 72 65 70 20 27 20 6d 6b 34 74 63 6c 20  | grep ' mk4tcl 
0dc0: 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f  ' >/dev/null 2>/
0dd0: 64 65 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e 0a 09  dev/null; then..
0de0: 09 69 66 20 5b 20 2d 7a 20 22 24 7b 53 54 41 54  .if [ -z "${STAT
0df0: 49 43 4d 4b 34 7d 22 20 5d 3b 20 74 68 65 6e 0a  ICMK4}" ]; then.
0e00: 09 09 09 65 63 68 6f 20 27 57 61 72 6e 69 6e 67  ...echo 'Warning
0e10: 3a 20 4c 69 6e 6b 69 6e 67 20 4d 6b 34 74 63 6c  : Linking Mk4tcl
0e20: 20 64 79 6e 61 6d 69 63 61 6c 6c 79 20 62 65 63   dynamically bec
0e30: 61 75 73 65 20 79 6f 75 20 61 72 65 20 62 75 69  ause you are bui
0e40: 6c 64 69 6e 67 20 4b 69 74 44 4c 4c 27 20 32 3e  lding KitDLL' 2>
0e50: 26 31 0a 09 09 09 65 63 68 6f 20 27 20 20 20 20  &1....echo '    
0e60: 20 20 20 20 20 53 65 74 20 53 54 41 54 49 43 4d       Set STATICM
0e70: 4b 34 20 74 6f 20 6d 61 6b 65 20 74 68 69 73 20  K4 to make this 
0e80: 6d 65 73 73 61 67 65 20 67 6f 20 61 77 61 79 2e  message go away.
0e90: 27 20 3e 26 32 0a 09 09 09 65 63 68 6f 20 27 20  ' >&2....echo ' 
0ea0: 20 20 20 20 20 20 20 20 53 65 74 20 53 54 41 54          Set STAT
0eb0: 49 43 4d 4b 34 20 74 6f 20 31 20 69 66 20 79 6f  ICMK4 to 1 if yo
0ec0: 75 20 72 65 61 6c 6c 79 20 77 61 6e 74 20 74 6f  u really want to
0ed0: 20 6c 69 6e 6b 20 4d 6b 34 74 63 6c 20 73 74 61   link Mk4tcl sta
0ee0: 74 69 63 61 6c 6c 79 20 28 6e 6f 72 6d 61 6c 20  tically (normal 
0ef0: 64 65 66 61 75 6c 74 29 2e 27 20 3e 26 32 0a 09  default).' >&2..
0f00: 09 09 65 63 68 6f 20 27 20 20 20 20 20 20 20 20  ..echo '        
0f10: 20 53 65 74 20 53 54 41 54 49 43 4d 4b 34 20 74   Set STATICMK4 t
0f20: 6f 20 30 20 74 6f 20 6c 69 6e 6b 20 4d 6b 34 74  o 0 to link Mk4t
0f30: 63 6c 20 64 79 6e 61 6d 69 63 61 6c 6c 79 20 69  cl dynamically i
0f40: 66 20 70 6f 73 73 69 62 6c 65 20 28 74 68 69 73  f possible (this
0f50: 20 69 73 20 77 68 61 74 20 69 73 20 68 61 70 70   is what is happ
0f60: 65 6e 69 6e 67 20 6e 6f 77 29 2e 27 20 3e 26 32  ening now).' >&2
0f70: 0a 09 09 09 65 63 68 6f 20 27 20 20 20 20 20 20  ....echo '      
0f80: 20 20 20 53 65 74 20 53 54 41 54 49 43 4d 4b 34     Set STATICMK4
0f90: 20 74 6f 20 2d 31 20 74 6f 20 62 75 69 6c 64 20   to -1 to build 
0fa0: 64 79 6e 61 6d 69 63 61 6c 6c 79 2e 27 20 3e 26  dynamically.' >&
0fb0: 32 0a 0a 09 09 09 53 54 41 54 49 43 4d 4b 34 3d  2.....STATICMK4=
0fc0: 22 30 22 0a 09 09 09 65 78 70 6f 72 74 20 53 54  "0"....export ST
0fd0: 41 54 49 43 4d 4b 34 0a 09 09 66 69 0a 09 66 69  ATICMK4...fi..fi
0fe0: 0a 66 69 0a 0a 23 20 46 69 6e 64 20 57 69 6e 64  .fi..# Find Wind
0ff0: 6f 77 73 20 72 65 73 6f 75 72 63 65 2d 72 65 6c  ows resource-rel
1000: 61 74 65 64 20 66 69 6c 65 73 0a 69 66 20 5b 20  ated files.if [ 
1010: 2d 66 20 22 6b 69 74 2e 69 63 6f 22 20 5d 3b 20  -f "kit.ico" ]; 
1020: 74 68 65 6e 0a 09 4b 49 54 43 52 45 41 54 4f 52  then..KITCREATOR
1030: 5f 49 43 4f 4e 3d 22 24 28 70 77 64 29 2f 6b 69  _ICON="$(pwd)/ki
1040: 74 2e 69 63 6f 22 0a 65 6c 73 65 0a 09 4b 49 54  t.ico".else..KIT
1050: 43 52 45 41 54 4f 52 5f 49 43 4f 4e 3d 22 24 28  CREATOR_ICON="$(
1060: 65 63 68 6f 20 22 24 28 70 77 64 29 2f 6b 69 74  echo "$(pwd)/kit
1070: 73 68 2f 62 75 69 6c 64 73 72 63 22 2f 6b 69 74  sh/buildsrc"/kit
1080: 73 68 2d 2a 2f 74 63 6c 6b 69 74 2e 69 63 6f 29  sh-*/tclkit.ico)
1090: 22 0a 66 69 0a 69 66 20 5b 20 2d 66 20 22 6b 69  ".fi.if [ -f "ki
10a0: 74 2e 72 63 22 20 5d 3b 20 74 68 65 6e 0a 09 4b  t.rc" ]; then..K
10b0: 49 54 43 52 45 41 54 4f 52 5f 52 43 3d 22 24 28  ITCREATOR_RC="$(
10c0: 70 77 64 29 2f 6b 69 74 2e 72 63 22 0a 65 6c 73  pwd)/kit.rc".els
10d0: 65 0a 09 4b 49 54 43 52 45 41 54 4f 52 5f 52 43  e..KITCREATOR_RC
10e0: 3d 22 24 28 65 63 68 6f 20 22 24 28 70 77 64 29  ="$(echo "$(pwd)
10f0: 2f 6b 69 74 73 68 2f 62 75 69 6c 64 73 72 63 22  /kitsh/buildsrc"
1100: 2f 6b 69 74 73 68 2d 2a 2f 6b 69 74 2e 72 63 29  /kitsh-*/kit.rc)
1110: 22 0a 66 69 0a 65 78 70 6f 72 74 20 4b 49 54 43  ".fi.export KITC
1120: 52 45 41 54 4f 52 5f 49 43 4f 4e 20 4b 49 54 43  REATOR_ICON KITC
1130: 52 45 41 54 4f 52 5f 52 43 0a 0a 23 20 44 65 74  REATOR_RC..# Det
1140: 65 72 6d 69 6e 65 20 68 6f 77 20 77 65 20 69 6e  ermine how we in
1150: 76 6f 6b 65 20 61 20 54 63 6c 20 69 6e 74 65 72  voke a Tcl inter
1160: 70 72 65 74 65 72 0a 69 66 20 5b 20 2d 7a 20 22  preter.if [ -z "
1170: 24 7b 54 43 4c 53 48 5f 4e 41 54 49 56 45 7d 22  ${TCLSH_NATIVE}"
1180: 20 5d 3b 20 74 68 65 6e 0a 09 54 43 4c 53 48 5f   ]; then..TCLSH_
1190: 4e 41 54 49 56 45 3d 22 66 61 6c 73 65 22 0a 66  NATIVE="false".f
11a0: 69 0a 66 6f 72 20 74 65 73 74 73 68 20 69 6e 20  i.for testsh in 
11b0: 22 24 7b 54 43 4c 53 48 5f 4e 41 54 49 56 45 7d  "${TCLSH_NATIVE}
11c0: 22 20 74 63 6c 73 68 20 74 63 6c 73 68 38 2e 34  " tclsh tclsh8.4
11d0: 20 74 63 6c 73 68 38 2e 35 20 74 63 6c 73 68 38   tclsh8.5 tclsh8
11e0: 2e 36 20 22 24 7b 54 43 4c 4b 49 54 3a 2d 74 63  .6 "${TCLKIT:-tc
11f0: 6c 6b 69 74 7d 22 3b 20 64 6f 0a 09 69 66 20 65  lkit}"; do..if e
1200: 63 68 6f 20 27 65 78 69 74 20 30 27 20 7c 20 22  cho 'exit 0' | "
1210: 24 7b 74 65 73 74 73 68 7d 22 20 3e 2f 64 65 76  ${testsh}" >/dev
1220: 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c  /null 2>/dev/nul
1230: 6c 3b 20 74 68 65 6e 0a 09 09 54 43 4c 53 48 5f  l; then...TCLSH_
1240: 4e 41 54 49 56 45 3d 22 24 7b 74 65 73 74 73 68  NATIVE="${testsh
1250: 7d 22 0a 0a 09 09 62 72 65 61 6b 0a 09 66 69 0a  }"....break..fi.
1260: 64 6f 6e 65 0a 65 78 70 6f 72 74 20 54 43 4c 53  done.export TCLS
1270: 48 5f 4e 41 54 49 56 45 0a 0a 23 20 46 75 6e 63  H_NATIVE..# Func
1280: 74 69 6f 6e 20 74 6f 20 64 65 74 65 72 6d 69 6e  tion to determin
1290: 65 20 77 68 61 74 20 62 75 69 6c 64 20 6d 6f 64  e what build mod
12a0: 65 20 69 73 20 62 65 69 6e 67 20 75 73 65 64 0a  e is being used.
12b0: 66 75 6e 63 74 69 6f 6e 20 75 73 65 43 6f 6d 6d  function useComm
12c0: 6f 6e 42 75 69 6c 64 53 79 73 74 65 6d 28 29 20  onBuildSystem() 
12d0: 7b 0a 09 6c 6f 63 61 6c 20 73 63 72 69 70 74 0a  {..local script.
12e0: 0a 09 73 63 72 69 70 74 3d 22 24 31 22 0a 0a 09  ..script="$1"...
12f0: 69 66 20 67 72 65 70 20 2d 69 20 27 5e 23 20 2a  if grep -i '^# *
1300: 42 75 69 6c 64 43 6f 6d 70 61 74 69 62 6c 65 3a  BuildCompatible:
1310: 20 2a 4b 69 74 43 72 65 61 74 6f 72 20 2a 24 27   *KitCreator *$'
1320: 20 22 24 7b 73 63 72 69 70 74 7d 22 20 3e 2f 64   "${script}" >/d
1330: 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e  ev/null 2>/dev/n
1340: 75 6c 6c 3b 20 74 68 65 6e 0a 09 09 72 65 74 75  ull; then...retu
1350: 72 6e 20 30 0a 09 66 69 0a 0a 09 72 65 74 75 72  rn 0..fi...retur
1360: 6e 20 31 0a 7d 0a 0a 23 20 43 6c 65 61 6e 75 70  n 1.}..# Cleanup
1370: 20 62 75 69 6c 64 20 6c 6f 67 73 0a 66 6f 72 20   build logs.for 
1380: 70 6b 67 20 69 6e 20 74 63 6c 20 74 63 6c 76 66  pkg in tcl tclvf
1390: 73 20 7a 6c 69 62 20 24 7b 4b 49 54 43 52 45 41  s zlib ${KITCREA
13a0: 54 4f 52 5f 50 4b 47 53 7d 20 6b 69 74 73 68 3b  TOR_PKGS} kitsh;
13b0: 20 64 6f 0a 09 72 6d 20 2d 66 20 22 24 7b 70 6b   do..rm -f "${pk
13c0: 67 7d 2f 62 75 69 6c 64 2e 6c 6f 67 22 0a 64 6f  g}/build.log".do
13d0: 6e 65 0a 0a 23 20 56 65 72 69 66 79 20 74 68 61  ne..# Verify tha
13e0: 74 20 65 61 63 68 20 63 6f 6d 70 6f 6e 65 6e 74  t each component
13f0: 20 69 73 20 68 61 70 70 79 20 77 69 74 68 20 74   is happy with t
1400: 68 65 20 65 6e 76 69 72 6f 6e 6d 65 6e 74 0a 76  he environment.v
1410: 61 6c 69 64 61 74 65 66 61 69 6c 65 64 3d 22 30  alidatefailed="0
1420: 22 0a 66 6f 72 20 70 6b 67 20 69 6e 20 74 63 6c  ".for pkg in tcl
1430: 20 74 63 6c 76 66 73 20 7a 6c 69 62 20 24 7b 4b   tclvfs zlib ${K
1440: 49 54 43 52 45 41 54 4f 52 5f 50 4b 47 53 7d 20  ITCREATOR_PKGS} 
1450: 6b 69 74 73 68 3b 20 64 6f 0a 09 66 61 69 6c 65  kitsh; do..faile
1460: 64 3d 27 30 27 0a 09 69 66 20 5b 20 2d 66 20 22  d='0'..if [ -f "
1470: 24 7b 70 6b 67 7d 2f 2e 73 75 63 63 65 73 73 22  ${pkg}/.success"
1480: 20 5d 3b 20 74 68 65 6e 0a 09 09 63 6f 6e 74 69   ]; then...conti
1490: 6e 75 65 0a 09 66 69 0a 0a 09 69 66 20 5b 20 2d  nue..fi...if [ -
14a0: 78 20 22 24 7b 70 6b 67 7d 2f 76 61 6c 69 64 61  x "${pkg}/valida
14b0: 74 65 2e 73 68 22 20 5d 3b 20 74 68 65 6e 0a 09  te.sh" ]; then..
14c0: 09 28 0a 09 09 09 63 64 20 22 24 7b 70 6b 67 7d  .(....cd "${pkg}
14d0: 22 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f  " >/dev/null 2>/
14e0: 64 65 76 2f 6e 75 6c 6c 20 7c 7c 20 65 78 69 74  dev/null || exit
14f0: 20 31 0a 0a 09 09 09 2e 2f 76 61 6c 69 64 61 74   1....../validat
1500: 65 2e 73 68 20 33 3e 26 31 20 34 3e 26 32 20 3e  e.sh 3>&1 4>&2 >
1510: 3e 20 62 75 69 6c 64 2e 6c 6f 67 20 32 3e 26 31  > build.log 2>&1
1520: 20 7c 7c 20 65 78 69 74 20 31 0a 09 09 29 20 7c   || exit 1...) |
1530: 7c 20 66 61 69 6c 65 64 3d 22 31 22 0a 0a 09 09  | failed="1"....
1540: 69 66 20 5b 20 22 24 7b 66 61 69 6c 65 64 7d 22  if [ "${failed}"
1550: 20 3d 20 27 31 27 20 5d 3b 20 74 68 65 6e 0a 09   = '1' ]; then..
1560: 09 09 65 63 68 6f 20 22 46 61 69 6c 65 64 20 70  ..echo "Failed p
1570: 72 65 2d 72 65 71 75 69 73 69 74 65 20 63 68 65  re-requisite che
1580: 63 6b 20 66 6f 72 20 24 7b 70 6b 67 7d 22 20 3e  ck for ${pkg}" >
1590: 26 32 0a 0a 09 09 09 76 61 6c 69 64 61 74 65 66  &2.....validatef
15a0: 61 69 6c 65 64 3d 27 31 27 0a 09 09 66 69 0a 09  ailed='1'...fi..
15b0: 66 69 0a 64 6f 6e 65 0a 0a 69 66 20 5b 20 22 24  fi.done..if [ "$
15c0: 7b 76 61 6c 69 64 61 74 65 66 61 69 6c 65 64 7d  {validatefailed}
15d0: 22 20 3d 20 27 31 27 20 5d 3b 20 74 68 65 6e 0a  " = '1' ]; then.
15e0: 09 65 78 69 74 20 31 0a 66 69 0a 0a 23 20 44 6f  .exit 1.fi..# Do
15f0: 20 62 75 69 6c 64 0a 66 61 69 6c 65 64 70 6b 67   build.failedpkg
1600: 73 3d 22 22 0a 62 75 69 6c 64 66 61 69 6c 65 64  s="".buildfailed
1610: 3d 22 30 22 0a 66 6f 72 20 70 6b 67 20 69 6e 20  ="0".for pkg in 
1620: 74 63 6c 20 74 63 6c 76 66 73 20 7a 6c 69 62 20  tcl tclvfs zlib 
1630: 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b 47  ${KITCREATOR_PKG
1640: 53 7d 20 6b 69 74 73 68 3b 20 64 6f 0a 09 66 61  S} kitsh; do..fa
1650: 69 6c 65 64 3d 22 30 22 0a 09 69 66 20 5b 20 2d  iled="0"..if [ -
1660: 66 20 22 24 7b 70 6b 67 7d 2f 2e 73 75 63 63 65  f "${pkg}/.succe
1670: 73 73 22 20 5d 3b 20 74 68 65 6e 0a 09 09 65 63  ss" ]; then...ec
1680: 68 6f 20 2d 6e 20 22 53 6b 69 70 70 69 6e 67 20  ho -n "Skipping 
1690: 24 7b 70 6b 67 7d 20 2e 2e 2e 22 0a 09 65 6c 73  ${pkg} ..."..els
16a0: 65 0a 09 09 65 63 68 6f 20 2d 6e 20 22 42 75 69  e...echo -n "Bui
16b0: 6c 64 69 6e 67 20 24 7b 70 6b 67 7d 20 2e 2e 2e  lding ${pkg} ...
16c0: 22 0a 0a 09 09 28 0a 09 09 09 63 64 20 22 24 7b  "....(....cd "${
16d0: 70 6b 67 7d 22 20 3e 2f 64 65 76 2f 6e 75 6c 6c  pkg}" >/dev/null
16e0: 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 20 7c 7c 20   2>/dev/null || 
16f0: 65 78 69 74 20 31 0a 0a 09 09 09 62 75 69 6c 64  exit 1.....build
1700: 5f 73 63 72 69 70 74 3d 27 2e 2f 62 75 69 6c 64  _script='./build
1710: 2e 73 68 27 0a 09 09 09 69 66 20 5b 20 2d 78 20  .sh'....if [ -x 
1720: 27 6b 69 74 63 72 65 61 74 6f 72 2d 62 75 69 6c  'kitcreator-buil
1730: 64 2e 73 68 27 20 5d 3b 20 74 68 65 6e 0a 09 09  d.sh' ]; then...
1740: 09 09 62 75 69 6c 64 5f 73 63 72 69 70 74 3d 27  ..build_script='
1750: 2e 2f 6b 69 74 63 72 65 61 74 6f 72 2d 62 75 69  ./kitcreator-bui
1760: 6c 64 2e 73 68 27 0a 09 09 09 66 69 0a 0a 09 09  ld.sh'....fi....
1770: 09 69 66 20 5b 20 2d 66 20 22 24 7b 62 75 69 6c  .if [ -f "${buil
1780: 64 5f 73 63 72 69 70 74 7d 22 20 5d 3b 20 74 68  d_script}" ]; th
1790: 65 6e 0a 09 09 09 09 62 75 69 6c 64 5f 73 63 72  en.....build_scr
17a0: 69 70 74 73 3d 28 22 24 7b 62 75 69 6c 64 5f 73  ipts=("${build_s
17b0: 63 72 69 70 74 7d 22 29 0a 09 09 09 65 6c 73 65  cript}")....else
17c0: 0a 09 09 09 09 62 75 69 6c 64 5f 73 63 72 69 70  .....build_scrip
17d0: 74 73 3d 28 24 28 65 63 68 6f 20 62 75 69 6c 64  ts=($(echo build
17e0: 2d 6b 69 74 63 72 65 61 74 6f 72 2d 2a 2e 73 68  -kitcreator-*.sh
17f0: 29 29 0a 09 09 09 66 69 0a 0a 09 09 09 63 61 6c  ))....fi.....cal
1800: 6c 5f 70 6b 67 5f 69 6e 69 74 3d 27 31 27 0a 09  l_pkg_init='1'..
1810: 09 09 66 6f 72 20 62 75 69 6c 64 5f 73 63 72 69  ..for build_scri
1820: 70 74 20 69 6e 20 22 24 7b 62 75 69 6c 64 5f 73  pt in "${build_s
1830: 63 72 69 70 74 73 5b 40 5d 7d 22 3b 20 64 6f 0a  cripts[@]}"; do.
1840: 09 09 09 09 69 66 20 75 73 65 43 6f 6d 6d 6f 6e  ....if useCommon
1850: 42 75 69 6c 64 53 79 73 74 65 6d 20 22 24 7b 62  BuildSystem "${b
1860: 75 69 6c 64 5f 73 63 72 69 70 74 7d 22 3b 20 74  uild_script}"; t
1870: 68 65 6e 0a 09 09 09 09 09 28 0a 09 09 09 09 09  hen......(......
1880: 09 2e 20 2e 2e 2f 63 6f 6d 6d 6f 6e 2f 63 6f 6d  .. ../common/com
1890: 6d 6f 6e 2e 73 68 0a 09 09 09 09 09 09 2e 20 22  mon.sh........ "
18a0: 24 7b 62 75 69 6c 64 5f 73 63 72 69 70 74 7d 22  ${build_script}"
18b0: 0a 0a 09 09 09 09 09 09 73 65 74 20 2d 78 0a 0a  ........set -x..
18c0: 09 09 09 09 09 09 69 66 20 5b 20 22 24 7b 63 61  ......if [ "${ca
18d0: 6c 6c 5f 70 6b 67 5f 69 6e 69 74 7d 22 20 3d 20  ll_pkg_init}" = 
18e0: 27 31 27 20 5d 3b 20 74 68 65 6e 0a 09 09 09 09  '1' ]; then.....
18f0: 09 09 09 69 6e 69 74 20 7c 7c 20 64 69 65 20 27  ...init || die '
1900: 69 6e 69 74 20 66 61 69 6c 65 64 27 0a 09 09 09  init failed'....
1910: 09 09 09 66 69 0a 0a 09 09 09 09 09 09 70 72 65  ...fi........pre
1920: 64 6f 77 6e 6c 6f 61 64 20 7c 7c 20 64 69 65 20  download || die 
1930: 27 70 72 65 64 6f 77 6e 6c 6f 61 64 20 66 61 69  'predownload fai
1940: 6c 65 64 27 0a 09 09 09 09 09 09 64 6f 77 6e 6c  led'.......downl
1950: 6f 61 64 20 7c 7c 20 64 69 65 20 27 64 6f 77 6e  oad || die 'down
1960: 6c 6f 61 64 20 66 61 69 6c 65 64 27 0a 09 09 09  load failed'....
1970: 09 09 09 70 6f 73 74 64 6f 77 6e 6c 6f 61 64 20  ...postdownload 
1980: 7c 7c 20 64 69 65 20 27 70 6f 73 74 64 6f 77 6e  || die 'postdown
1990: 6c 6f 61 64 20 66 61 69 6c 65 64 27 0a 0a 09 09  load failed'....
19a0: 09 09 09 09 65 78 74 72 61 63 74 20 7c 7c 20 64  ....extract || d
19b0: 69 65 20 27 65 78 74 72 61 63 74 20 66 61 69 6c  ie 'extract fail
19c0: 65 64 27 0a 0a 09 09 09 09 09 09 61 70 70 6c 79  ed'........apply
19d0: 5f 70 61 74 63 68 65 73 20 7c 7c 20 64 69 65 20  _patches || die 
19e0: 27 61 70 70 6c 79 20 70 61 74 63 68 65 73 20 66  'apply patches f
19f0: 61 69 6c 65 64 27 0a 0a 09 09 09 09 09 09 63 64  ailed'........cd
1a00: 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 20 7c 7c   "${workdir}" ||
1a10: 20 65 78 69 74 20 31 0a 0a 09 09 09 09 09 09 70   exit 1........p
1a20: 72 65 63 6f 6e 66 69 67 75 72 65 20 7c 7c 20 64  reconfigure || d
1a30: 69 65 20 27 70 72 65 63 6f 6e 66 69 67 75 72 65  ie 'preconfigure
1a40: 20 66 61 69 6c 65 64 27 0a 09 09 09 09 09 09 63   failed'.......c
1a50: 6f 6e 66 69 67 75 72 65 20 7c 7c 20 64 69 65 20  onfigure || die 
1a60: 27 63 6f 6e 66 69 67 75 72 65 20 66 61 69 6c 65  'configure faile
1a70: 64 27 0a 09 09 09 09 09 09 70 6f 73 74 63 6f 6e  d'.......postcon
1a80: 66 69 67 75 72 65 20 7c 7c 20 64 69 65 20 27 70  figure || die 'p
1a90: 6f 73 74 63 6f 6e 66 69 67 75 72 65 20 66 61 69  ostconfigure fai
1aa0: 6c 65 64 27 0a 0a 09 09 09 09 09 09 70 72 65 62  led'........preb
1ab0: 75 69 6c 64 20 7c 7c 20 64 69 65 20 27 70 72 65  uild || die 'pre
1ac0: 62 75 69 6c 64 20 66 61 69 6c 65 64 27 0a 09 09  build failed'...
1ad0: 09 09 09 09 62 75 69 6c 64 20 7c 7c 20 64 69 65  ....build || die
1ae0: 20 27 62 75 69 6c 64 20 66 61 69 6c 65 64 27 0a   'build failed'.
1af0: 09 09 09 09 09 09 70 6f 73 74 62 75 69 6c 64 20  ......postbuild 
1b00: 7c 7c 20 64 69 65 20 27 70 6f 73 74 62 75 69 6c  || die 'postbuil
1b10: 64 20 66 61 69 6c 65 64 27 0a 0a 09 09 09 09 09  d failed'.......
1b20: 09 70 72 65 69 6e 73 74 61 6c 6c 20 7c 7c 20 64  .preinstall || d
1b30: 69 65 20 27 70 72 65 69 6e 73 74 61 6c 6c 20 66  ie 'preinstall f
1b40: 61 69 6c 65 64 27 0a 09 09 09 09 09 09 69 6e 73  ailed'.......ins
1b50: 74 61 6c 6c 20 7c 7c 20 64 69 65 20 27 69 6e 73  tall || die 'ins
1b60: 74 61 6c 6c 20 66 61 69 6c 65 64 27 0a 09 09 09  tall failed'....
1b70: 09 09 09 70 6f 73 74 69 6e 73 74 61 6c 6c 20 7c  ...postinstall |
1b80: 7c 20 64 69 65 20 27 70 6f 73 74 69 6e 73 74 61  | die 'postinsta
1b90: 6c 6c 20 66 61 69 6c 65 64 27 0a 0a 09 09 09 09  ll failed'......
1ba0: 09 09 63 72 65 61 74 65 72 75 6e 74 69 6d 65 20  ..createruntime 
1bb0: 7c 7c 20 64 69 65 20 27 63 72 65 61 74 65 72 75  || die 'createru
1bc0: 6e 74 69 6d 65 20 66 61 69 6c 65 64 27 0a 0a 09  ntime failed'...
1bd0: 09 09 09 09 09 73 65 74 20 2b 78 0a 09 09 09 09  .....set +x.....
1be0: 09 29 20 33 3e 26 31 20 34 3e 26 32 20 3e 3e 20  .) 3>&1 4>&2 >> 
1bf0: 62 75 69 6c 64 2e 6c 6f 67 20 32 3e 26 31 20 7c  build.log 2>&1 |
1c00: 7c 20 65 78 69 74 20 31 0a 09 09 09 09 65 6c 73  | exit 1.....els
1c10: 65 0a 09 09 09 09 09 22 24 7b 62 75 69 6c 64 5f  e......"${build_
1c20: 73 63 72 69 70 74 7d 22 20 33 3e 26 31 20 34 3e  script}" 3>&1 4>
1c30: 26 32 20 3e 3e 20 62 75 69 6c 64 2e 6c 6f 67 20  &2 >> build.log 
1c40: 32 3e 26 31 20 7c 7c 20 65 78 69 74 20 31 0a 09  2>&1 || exit 1..
1c50: 09 09 09 66 69 0a 0a 09 09 09 09 63 61 6c 6c 5f  ...fi......call_
1c60: 70 6b 67 5f 69 6e 69 74 3d 27 30 27 0a 09 09 09  pkg_init='0'....
1c70: 64 6f 6e 65 0a 09 09 29 20 7c 7c 20 66 61 69 6c  done...) || fail
1c80: 65 64 3d 22 31 22 0a 09 66 69 0a 0a 09 69 66 20  ed="1"..fi...if 
1c90: 5b 20 22 24 7b 66 61 69 6c 65 64 7d 22 20 3d 20  [ "${failed}" = 
1ca0: 22 31 22 20 5d 3b 20 74 68 65 6e 0a 09 09 65 63  "1" ]; then...ec
1cb0: 68 6f 20 22 20 66 61 69 6c 65 64 2e 22 0a 09 09  ho " failed."...
1cc0: 66 61 69 6c 65 64 70 6b 67 73 3d 22 24 7b 66 61  failedpkgs="${fa
1cd0: 69 6c 65 64 70 6b 67 73 7d 20 24 7b 70 6b 67 7d  iledpkgs} ${pkg}
1ce0: 22 0a 09 65 6c 73 65 0a 09 09 65 63 68 6f 20 22  "..else...echo "
1cf0: 20 64 6f 6e 65 2e 22 0a 09 66 69 0a 0a 09 63 61   done."..fi...ca
1d00: 73 65 20 22 24 7b 70 6b 67 7d 22 20 69 6e 0a 09  se "${pkg}" in..
1d10: 09 74 63 6c 29 0a 09 09 09 54 43 4c 43 4f 4e 46  .tcl)....TCLCONF
1d20: 49 47 44 49 52 3d 24 28 66 69 6e 64 20 22 24 28  IGDIR=$(find "$(
1d30: 70 77 64 29 2f 74 63 6c 2f 62 75 69 6c 64 22 20  pwd)/tcl/build" 
1d40: 2d 6e 61 6d 65 20 74 63 6c 43 6f 6e 66 69 67 2e  -name tclConfig.
1d50: 73 68 20 7c 20 68 65 61 64 20 2d 31 20 7c 20 73  sh | head -1 | s
1d60: 65 64 20 27 73 40 2f 5b 5e 2f 5d 2a 24 40 40 27  ed 's@/[^/]*$@@'
1d70: 29 0a 09 09 09 54 43 4c 43 4f 4e 46 49 47 44 49  )....TCLCONFIGDI
1d80: 52 54 41 49 4c 3d 22 24 28 62 61 73 65 6e 61 6d  RTAIL="$(basenam
1d90: 65 20 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44 49  e "${TCLCONFIGDI
1da0: 52 7d 22 29 22 0a 09 09 09 65 78 70 6f 72 74 20  R}")"....export 
1db0: 54 43 4c 43 4f 4e 46 49 47 44 49 52 20 54 43 4c  TCLCONFIGDIR TCL
1dc0: 43 4f 4e 46 49 47 44 49 52 54 41 49 4c 0a 0a 09  CONFIGDIRTAIL...
1dd0: 09 09 23 20 49 66 20 54 63 6c 20 77 61 73 20 63  ..# If Tcl was c
1de0: 6f 6d 70 69 6c 65 64 20 77 69 74 68 20 74 68 72  ompiled with thr
1df0: 65 61 64 73 20 65 6e 61 62 6c 65 64 20 70 61 73  eads enabled pas
1e00: 73 20 2d 2d 65 6e 61 62 6c 65 2d 74 68 72 65 61  s --enable-threa
1e10: 64 73 20 74 6f 20 61 6c 6c 20 73 75 62 2d 70 72  ds to all sub-pr
1e20: 6f 6a 65 63 74 73 0a 09 09 09 69 66 20 5b 20 22  ojects....if [ "
1e30: 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f 41 44 44  ${KITCREATOR_ADD
1e40: 5f 45 4e 41 42 4c 45 5f 54 48 52 45 41 44 53 3a  _ENABLE_THREADS:
1e50: 2d 31 7d 22 20 21 3d 20 27 30 27 20 5d 3b 20 74  -1}" != '0' ]; t
1e60: 68 65 6e 0a 09 09 09 09 69 66 20 5b 20 22 24 28  hen.....if [ "$(
1e70: 20 2e 20 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44   . "${TCLCONFIGD
1e80: 49 52 7d 2f 74 63 6c 43 6f 6e 66 69 67 2e 73 68  IR}/tclConfig.sh
1e90: 22 20 26 26 20 65 63 68 6f 20 22 24 7b 54 43 4c  " && echo "${TCL
1ea0: 5f 54 48 52 45 41 44 53 3a 2d 30 7d 22 20 29 22  _THREADS:-0}" )"
1eb0: 20 3d 20 27 31 27 20 5d 3b 20 74 68 65 6e 0a 09   = '1' ]; then..
1ec0: 09 09 09 09 43 4f 4e 46 49 47 55 52 45 45 58 54  ....CONFIGUREEXT
1ed0: 52 41 3d 22 24 7b 43 4f 4e 46 49 47 55 52 45 45  RA="${CONFIGUREE
1ee0: 58 54 52 41 7d 20 2d 2d 65 6e 61 62 6c 65 2d 74  XTRA} --enable-t
1ef0: 68 72 65 61 64 73 22 0a 09 09 09 09 66 69 0a 09  hreads".....fi..
1f00: 09 09 66 69 0a 09 09 09 3b 3b 0a 09 65 73 61 63  ..fi....;;..esac
1f10: 0a 0a 09 69 66 20 5b 20 22 24 7b 66 61 69 6c 65  ...if [ "${faile
1f20: 64 7d 22 20 3d 20 22 31 22 20 5d 3b 20 74 68 65  d}" = "1" ]; the
1f30: 6e 0a 09 09 62 75 69 6c 64 66 61 69 6c 65 64 3d  n...buildfailed=
1f40: 22 31 22 0a 09 65 6c 73 65 0a 09 09 74 6f 75 63  "1"..else...touc
1f50: 68 20 22 24 7b 70 6b 67 7d 2f 2e 73 75 63 63 65  h "${pkg}/.succe
1f60: 73 73 22 0a 09 66 69 0a 64 6f 6e 65 0a 0a 69 66  ss"..fi.done..if
1f70: 20 5b 20 2d 6e 20 22 24 7b 66 61 69 6c 65 64 70   [ -n "${failedp
1f80: 6b 67 73 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 65  kgs}" ]; then..e
1f90: 63 68 6f 20 22 46 61 69 6c 65 64 20 74 6f 20 62  cho "Failed to b
1fa0: 75 69 6c 64 3a 24 7b 66 61 69 6c 65 64 70 6b 67  uild:${failedpkg
1fb0: 73 7d 22 0a 66 69 0a 0a 69 66 20 5b 20 22 24 7b  s}".fi..if [ "${
1fc0: 62 75 69 6c 64 66 61 69 6c 65 64 7d 22 20 21 3d  buildfailed}" !=
1fd0: 20 22 30 22 20 5d 3b 20 74 68 65 6e 0a 09 65 63   "0" ]; then..ec
1fe0: 68 6f 20 27 57 41 52 4e 49 4e 47 3a 20 42 75 69  ho 'WARNING: Bui
1ff0: 6c 64 20 69 73 20 6c 69 6b 65 6c 79 20 69 6e 63  ld is likely inc
2000: 6f 6d 70 6c 65 74 65 20 6f 72 20 66 61 69 6c 65  omplete or faile
2010: 64 2e 27 20 3e 26 32 0a 66 69 0a 0a 63 70 20 27  d.' >&2.fi..cp '
2020: 6b 69 74 73 68 2f 62 75 69 6c 64 27 2f 6b 69 74  kitsh/build'/kit
2030: 73 68 2d 2a 2f 6c 69 62 74 63 6c 6b 69 74 2a 20  sh-*/libtclkit* 
2040: 2e 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f  . >/dev/null 2>/
2050: 64 65 76 2f 6e 75 6c 6c 0a 63 70 20 27 6b 69 74  dev/null.cp 'kit
2060: 73 68 2f 62 75 69 6c 64 27 2f 6b 69 74 73 68 2d  sh/build'/kitsh-
2070: 2a 2f 6b 69 74 20 22 74 63 6c 6b 69 74 2d 24 7b  */kit "tclkit-${
2080: 54 43 4c 56 45 52 53 7d 22 20 3e 2f 64 65 76 2f  TCLVERS}" >/dev/
2090: 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c  null 2>/dev/null
20a0: 0a 69 66 20 5b 20 21 20 2d 66 20 22 74 63 6c 6b  .if [ ! -f "tclk
20b0: 69 74 2d 24 7b 54 43 4c 56 45 52 53 7d 22 20 5d  it-${TCLVERS}" ]
20c0: 3b 20 74 68 65 6e 0a 09 63 70 20 27 6b 69 74 73  ; then..cp 'kits
20d0: 68 2f 62 75 69 6c 64 27 2f 6b 69 74 73 68 2d 2a  h/build'/kitsh-*
20e0: 2f 6b 69 74 2e 65 78 65 20 22 74 63 6c 6b 69 74  /kit.exe "tclkit
20f0: 2d 24 7b 54 43 4c 56 45 52 53 7d 22 20 3e 2f 64  -${TCLVERS}" >/d
2100: 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e  ev/null 2>/dev/n
2110: 75 6c 6c 0a 66 69 0a 0a 66 6f 72 20 70 6f 73 74  ull.fi..for post
2120: 73 63 72 69 70 74 20 69 6e 20 63 6f 6d 6d 6f 6e  script in common
2130: 2f 70 6f 73 74 2f 2a 3b 20 64 6f 0a 09 69 66 20  /post/*; do..if 
2140: 5b 20 21 20 2d 66 20 22 24 7b 70 6f 73 74 73 63  [ ! -f "${postsc
2150: 72 69 70 74 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  ript}" ]; then..
2160: 09 63 6f 6e 74 69 6e 75 65 0a 09 66 69 0a 0a 09  .continue..fi...
2170: 22 24 7b 70 6f 73 74 73 63 72 69 70 74 7d 22 0a  "${postscript}".
2180: 64 6f 6e 65 0a 0a 65 78 69 74 20 22 24 7b 62 75  done..exit "${bu
2190: 69 6c 64 66 61 69 6c 65 64 7d 22 0a              ildfailed}".